# Sequence

# 0..40 - Rotation
# 60..100 - Laser
# 140..180 - Rocket & Rotation
# 200..240 - Laser
# 280..300 - Stomp
# 280..320 - Swoop
# 360..400 - Rotation
# 400.. - Constant Rotation
# 420..460 - Laser
# 460 - Death







# Target players

execute as @a if score @s chess.id = #white_player chess.id run tag @s add white_player
execute as @a if score @s chess.id = #black_player chess.id run tag @s add black_player







# Angle anchor transformations

execute if score #timer chess.value matches 000 as @e[type=marker,tag=angle_anchor] store result score @s chess.start_x run data get entity @s Pos[0] 100
execute if score #timer chess.value matches 000 as @e[type=marker,tag=angle_anchor] store result score @s chess.start_y run data get entity @s Pos[1] 100
execute if score #timer chess.value matches 000 as @e[type=marker,tag=angle_anchor] store result score @s chess.start_z run data get entity @s Pos[2] 100
execute if score #timer chess.value matches 000 run tag @e[type=marker,tag=angle_anchor] add transformation

execute if score #timer chess.value matches 140 as @e[type=marker,tag=angle_anchor] store result score @s chess.start_x run data get entity @s Pos[0] 100
execute if score #timer chess.value matches 140 as @e[type=marker,tag=angle_anchor] store result score @s chess.start_y run data get entity @s Pos[1] 100
execute if score #timer chess.value matches 140 as @e[type=marker,tag=angle_anchor] store result score @s chess.start_z run data get entity @s Pos[2] 100
execute if score #timer chess.value matches 140 run tag @e[type=marker,tag=angle_anchor] add transformation

execute if score #timer chess.value matches 360 as @e[type=marker,tag=angle_anchor] store result score @s chess.start_x run data get entity @s Pos[0] 100
execute if score #timer chess.value matches 360 as @e[type=marker,tag=angle_anchor] store result score @s chess.start_y run data get entity @s Pos[1] 100
execute if score #timer chess.value matches 360 as @e[type=marker,tag=angle_anchor] store result score @s chess.start_z run data get entity @s Pos[2] 100
execute if score #timer chess.value matches 360 run tag @e[type=marker,tag=angle_anchor] add transformation



execute store result score @e[type=marker,tag=angle_anchor,tag=white,limit=1] chess.end_x run data get entity @a[tag=white_player,limit=1] Pos[0] 100
execute store result score @e[type=marker,tag=angle_anchor,tag=white,limit=1] chess.end_y run data get entity @a[tag=white_player,limit=1] Pos[1] 100
execute store result score @e[type=marker,tag=angle_anchor,tag=white,limit=1] chess.end_z run data get entity @a[tag=white_player,limit=1] Pos[2] 100

execute store result score @e[type=marker,tag=angle_anchor,tag=black,limit=1] chess.end_x run data get entity @a[tag=black_player,limit=1] Pos[0] 100
execute store result score @e[type=marker,tag=angle_anchor,tag=black,limit=1] chess.end_y run data get entity @a[tag=black_player,limit=1] Pos[1] 100
execute store result score @e[type=marker,tag=angle_anchor,tag=black,limit=1] chess.end_z run data get entity @a[tag=black_player,limit=1] Pos[2] 100

scoreboard players add @e[type=marker,tag=angle_anchor] chess.end_y 100



execute if score #timer chess.value matches 400.. as @e[type=marker,tag=angle_anchor,tag=white,limit=1] at @a[tag=white_player,limit=1] run teleport @s ~ ~1 ~
execute if score #timer chess.value matches 400.. as @e[type=marker,tag=angle_anchor,tag=black,limit=1] at @a[tag=black_player,limit=1] run teleport @s ~ ~1 ~







# King transformations

execute if score #timer chess.value matches 140 as @e[type=block_display,tag=chess_piece,tag=king] store result score @s chess.start_x run data get entity @s Pos[0] 100
execute if score #timer chess.value matches 140 as @e[type=block_display,tag=chess_piece,tag=king] store result score @s chess.start_y run data get entity @s Pos[1] 100
execute if score #timer chess.value matches 140 as @e[type=block_display,tag=chess_piece,tag=king] store result score @s chess.start_z run data get entity @s Pos[2] 100
execute if score #timer chess.value matches 140 as @e[type=block_display,tag=chess_piece,tag=king] run scoreboard players operation @s chess.end_x = @s chess.start_x
execute if score #timer chess.value matches 140 as @e[type=block_display,tag=chess_piece,tag=king] run scoreboard players set @s chess.end_y 6700
execute if score #timer chess.value matches 140 as @e[type=block_display,tag=chess_piece,tag=king] run scoreboard players operation @s chess.end_z = @s chess.start_z
execute if score #timer chess.value matches 140 run tag @e[type=block_display,tag=chess_piece,tag=king] add transformation

execute if score #timer chess.value matches 280 as @e[type=block_display,tag=chess_piece,tag=king] run scoreboard players operation @s chess.start_x = @s chess.end_x
execute if score #timer chess.value matches 280 as @e[type=block_display,tag=chess_piece,tag=king] run scoreboard players operation @s chess.start_y = @s chess.end_y
execute if score #timer chess.value matches 280 as @e[type=block_display,tag=chess_piece,tag=king] run scoreboard players operation @s chess.start_z = @s chess.end_z
execute if score #timer chess.value matches 280..320 store result score @e[type=block_display,tag=chess_piece,tag=king,tag=white,limit=1] chess.end_x run data get entity @a[tag=white_player,limit=1] Pos[0] 100
execute if score #timer chess.value matches 280..320 store result score @e[type=block_display,tag=chess_piece,tag=king,tag=white,limit=1] chess.end_y run data get entity @a[tag=white_player,limit=1] Pos[1] 100
execute if score #timer chess.value matches 280..320 store result score @e[type=block_display,tag=chess_piece,tag=king,tag=white,limit=1] chess.end_z run data get entity @a[tag=white_player,limit=1] Pos[2] 100
execute if score #timer chess.value matches 280 run scoreboard players set @e[type=block_display,tag=chess_piece,tag=king,tag=black] chess.end_y 6400
execute if score #timer chess.value matches 280 run tag @e[type=block_display,tag=chess_piece,tag=king,tag=white] add transformation
execute if score #timer chess.value matches 280 run tag @e[type=block_display,tag=chess_piece,tag=king,tag=black] add gravity

execute if score #timer chess.value matches 320 as @e[type=block_display,tag=chess_piece,tag=king,tag=white] run scoreboard players operation @s chess.start_x = @s chess.end_x
execute if score #timer chess.value matches 320 as @e[type=block_display,tag=chess_piece,tag=king,tag=white] run scoreboard players operation @s chess.start_y = @s chess.end_y
execute if score #timer chess.value matches 320 as @e[type=block_display,tag=chess_piece,tag=king,tag=white] run scoreboard players operation @s chess.start_z = @s chess.end_z
execute if score #timer chess.value matches 320 as @e[type=block_display,tag=chess_piece,tag=king,tag=white] run scoreboard players set @s chess.end_y 6700
execute if score #timer chess.value matches 320 run tag @e[type=block_display,tag=chess_piece,tag=king,tag=white] add transformation







# Rotate kings

execute as @e[type=block_display,tag=chess_piece,tag=white,tag=king] at @s positioned ~ ~1.8125 ~ facing entity @e[type=marker,tag=angle_anchor,tag=white,limit=1] feet run teleport @s ~ ~-1.8125 ~ ~ ~
execute as @e[type=block_display,tag=chess_piece,tag=black,tag=king] at @s positioned ~ ~1.8125 ~ facing entity @e[type=marker,tag=angle_anchor,tag=black,limit=1] feet run teleport @s ~ ~-1.8125 ~ ~ ~







# Lasers

execute if score #timer chess.value matches 060 run tag @e[type=block_display,tag=chess_piece,tag=king] add laser
execute if score #timer chess.value matches 200 run tag @e[type=block_display,tag=chess_piece,tag=king] add laser
execute if score #timer chess.value matches 420 run tag @e[type=block_display,tag=chess_piece,tag=king] add laser

execute if score #timer chess.value matches 060 run scoreboard players set @a chess.laser 0
execute if score #timer chess.value matches 200 run scoreboard players set @a chess.laser 0
execute if score #timer chess.value matches 420 run scoreboard players set @a chess.laser 0







# Rocket

execute if score #timer chess.value matches 140 run tag @e[type=block_display,tag=chess_piece,tag=king] add rocket
execute if score #timer chess.value matches 280 run tag @e[type=block_display,tag=chess_piece,tag=king,tag=black] remove rocket







# Damage

execute if score #timer chess.value matches 300 run playsound minecraft:entity.generic.explode master @a 4 64 4
execute if score #timer chess.value matches 300 run particle cloud 4.0 64 4.0 4 0 4 0.1 1000 force
execute if score #timer chess.value matches 300 run effect give @a[nbt={OnGround:1b}] instant_damage 1 0 true

execute if score #timer chess.value matches 320 at @e[type=block_display,tag=chess_piece,tag=king,tag=white] run effect give @a[distance=..1] instant_damage 1 0 true

execute if score #timer chess.value matches 460 run kill @a[tag=white_player]
execute if score #timer chess.value matches 460 run kill @a[tag=black_player]







# Increment timer

scoreboard players add #timer chess.value 1







# Remove tags

tag @a remove white_player
tag @a remove black_player







# End animation

execute if score #timer chess.value matches 480.. run function chess:phase/1/start